import 'package:flutter/services.dart';
import 'package:packages_info_platform_interface/option.dart';
import 'package:packages_info_platform_interface/package.dart';
import 'package:packages_info_platform_interface/packages_info_platform_interface.dart';

const MethodChannel _kChannel = packagesInfoMethodChannel;

class PackagesInfoAndroid extends PackagesInfoPlatform {
  @override
  Future<Iterable<Package>> getInstalledPackages([
    Options options = const Options(),
  ]) async {
    final _packages = await _kChannel.invokeListMethod(
            'getInstalledPackages', options.toMap) ??
        [];
    return _packages.map((it) => Package.fromMap(it));
  }

  @override
  Future<Package> getPackageInfo(
    String packageIdentifier, [
    Options options = const Options(),
  ]) async {
    final _options = options.copyWith(packageIdentifier: packageIdentifier);
    final _package =
        await _kChannel.invokeMapMethod('getPackageInfo', _options.toMap) ?? {};

    return Package.fromMap(_package);
  }
}
